stages:
  - build
  - sonarcloud-check

variables:
  RULES_CHANGES_PATH: "**/*"
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task

sonarcloud-check-project-1:
  stage: sonarcloud-check
  image: gradle:jre11-slim
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script: ./gradlew :project1:sonar -Dsonar.qualitygate.wait=true -Dsonar.qualitygate.timeout=300
  allow_failure: true
  rules:
    - if: $CI_COMMIT_REF_NAME == 'main' || $CI_PIPELINE_SOURCE == 'merge_request_event'

sonarcloud-check-project-2:
  stage: sonarcloud-check
  image: gradle:jre11-slim
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script: ./gradlew :project2:sonar -Dsonar.qualitygate.wait=true -Dsonar.qualitygate.timeout=300
  allow_failure: true
  rules:
    - if: $CI_COMMIT_REF_NAME == 'main' || $CI_PIPELINE_SOURCE == 'merge_request_event'

.base-rules:
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: always
    - if: '$CI_PIPELINE_SOURCE == "push"' #avoiding duplicated jobs for MR and branch
      when: never
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      changes:
        - $RULES_CHANGES_PATH

.project1:
  extends: .base-rules
  variables:
    RULES_CHANGES_PATH: "project1/**/*"

.project2:
  extends: .base-rules
  variables:
    RULES_CHANGES_PATH: "project2/**/*"

project1-build:
  stage: build
  image: gradle:jre11-slim
  extends: .project1
  needs: []
  script:
    - echo "Compiling the project1 code..."
    - ./gradlew :project1:build

project2-build:
  stage: build
  image: gradle:jre11-slim
  extends: .project2
  needs: []
  script:
    - echo "Compiling the project2 code..."
    - ./gradlew :project2:build
